#include "cssysdef.h"
#include "cstool/initapp.h"
#include "csutil/event.h"
#include "iutil/eventq.h"
#include "csutil/ref.h"
#include "state.h"

#include "isound/handle.h"
#include "isound/source.h"
#include "isound/data.h"
#include "isound/renderer.h"
#include "isound/wrapper.h"

State::State(iObjectRegistry* object_reg, csRef<iLoader> loader, csRef<iSoundRender> render, bool play_in_state)
{
    State::object_reg = object_reg;
    State::loader = loader;
    State::render = render;

    if (play_in_state)
    {
        csRef<iSoundData> data = loader->LoadSoundData("/path/to/file.ogg");
        if (data)
        {
            csRef<iSoundHandle> handle = render->RegisterSound(data);
            csRef<iSoundSource> source = handle->CreateSource(SOUND3D_DISABLE);
            source->SetVolume(1);
            if (!handle->IsStatic())
                handle->StartStream(true);
            source->Play(false);
        }
    }
}

State::~State()
{
}

void State::SetupFrame(float elapsed_seconds)
{
}

bool State::HandleEvent(iEvent& ev)
{
    if (csKeyEventHelper::GetEventType(&ev) == csKeyEventTypeDown && csKeyEventHelper::GetCookedCode(&ev) == CSKEY_ESC)
    {
        csRef<iEventQueue> q = CS_QUERY_REGISTRY(object_reg, iEventQueue);

        if (q)
            q->GetEventOutlet()->Broadcast(cscmdQuit);
        return true;
    }
    return false;
}
